/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the OneDriveDestinationAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OneDriveDestinationAllOf{}

// OneDriveDestinationAllOf struct for OneDriveDestinationAllOf
type OneDriveDestinationAllOf struct {
	OAuthId *int32         `json:"o_auth_id,omitempty"`
	DriveId NullableString `json:"drive_id,omitempty"`
	Tenant  NullableString `json:"tenant,omitempty"`
}

// NewOneDriveDestinationAllOf instantiates a new OneDriveDestinationAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOneDriveDestinationAllOf() *OneDriveDestinationAllOf {
	this := OneDriveDestinationAllOf{}
	return &this
}

// NewOneDriveDestinationAllOfWithDefaults instantiates a new OneDriveDestinationAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOneDriveDestinationAllOfWithDefaults() *OneDriveDestinationAllOf {
	this := OneDriveDestinationAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *OneDriveDestinationAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OneDriveDestinationAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *OneDriveDestinationAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *OneDriveDestinationAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetDriveId returns the DriveId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OneDriveDestinationAllOf) GetDriveId() string {
	if o == nil || IsNil(o.DriveId.Get()) {
		var ret string
		return ret
	}
	return *o.DriveId.Get()
}

// GetDriveIdOk returns a tuple with the DriveId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OneDriveDestinationAllOf) GetDriveIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DriveId.Get(), o.DriveId.IsSet()
}

// HasDriveId returns a boolean if a field has been set.
func (o *OneDriveDestinationAllOf) HasDriveId() bool {
	if o != nil && o.DriveId.IsSet() {
		return true
	}

	return false
}

// SetDriveId gets a reference to the given NullableString and assigns it to the DriveId field.
func (o *OneDriveDestinationAllOf) SetDriveId(v string) {
	o.DriveId.Set(&v)
}

// SetDriveIdNil sets the value for DriveId to be an explicit nil
func (o *OneDriveDestinationAllOf) SetDriveIdNil() {
	o.DriveId.Set(nil)
}

// UnsetDriveId ensures that no value is present for DriveId, not even an explicit nil
func (o *OneDriveDestinationAllOf) UnsetDriveId() {
	o.DriveId.Unset()
}

// GetTenant returns the Tenant field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OneDriveDestinationAllOf) GetTenant() string {
	if o == nil || IsNil(o.Tenant.Get()) {
		var ret string
		return ret
	}
	return *o.Tenant.Get()
}

// GetTenantOk returns a tuple with the Tenant field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OneDriveDestinationAllOf) GetTenantOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Tenant.Get(), o.Tenant.IsSet()
}

// HasTenant returns a boolean if a field has been set.
func (o *OneDriveDestinationAllOf) HasTenant() bool {
	if o != nil && o.Tenant.IsSet() {
		return true
	}

	return false
}

// SetTenant gets a reference to the given NullableString and assigns it to the Tenant field.
func (o *OneDriveDestinationAllOf) SetTenant(v string) {
	o.Tenant.Set(&v)
}

// SetTenantNil sets the value for Tenant to be an explicit nil
func (o *OneDriveDestinationAllOf) SetTenantNil() {
	o.Tenant.Set(nil)
}

// UnsetTenant ensures that no value is present for Tenant, not even an explicit nil
func (o *OneDriveDestinationAllOf) UnsetTenant() {
	o.Tenant.Unset()
}

func (o OneDriveDestinationAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OneDriveDestinationAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if o.DriveId.IsSet() {
		toSerialize["drive_id"] = o.DriveId.Get()
	}
	if o.Tenant.IsSet() {
		toSerialize["tenant"] = o.Tenant.Get()
	}
	return toSerialize, nil
}

type NullableOneDriveDestinationAllOf struct {
	value *OneDriveDestinationAllOf
	isSet bool
}

func (v NullableOneDriveDestinationAllOf) Get() *OneDriveDestinationAllOf {
	return v.value
}

func (v *NullableOneDriveDestinationAllOf) Set(val *OneDriveDestinationAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableOneDriveDestinationAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableOneDriveDestinationAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOneDriveDestinationAllOf(val *OneDriveDestinationAllOf) *NullableOneDriveDestinationAllOf {
	return &NullableOneDriveDestinationAllOf{value: val, isSet: true}
}

func (v NullableOneDriveDestinationAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOneDriveDestinationAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
